import Config from "./config";
import { AxiosResponse, AxiosRequestConfig } from "axios";
import { ResultType } from "./response_validation_context";
import Response from "./response";
interface ValidationResult {
    type: ResultType;
    data: any;
}
declare class Api {
    config: Config;
    constructor(config?: Config);
    extend(config: Config): Api;
    headers(method: string): any;
    transformData(data?: any): any;
    transformResponse(response?: any): any;
    buildAxiosConfig(method: string, url: string, data?: any): AxiosRequestConfig;
    executeBefores(): void;
    executeAfters(): void;
    executeResponseValidations(response: any, orgResponse: AxiosResponse): Promise<ValidationResult>;
    handleException<T>(e: any): Response<T>;
    transformAndValidateResponse<T>(response: AxiosResponse, method: string, url: string, data: any, retry: boolean, retryNum: number): Promise<Response<T>>;
    requestInternal<T>(method: string, url: string, data: any, retry?: boolean, retryNum?: number): Promise<Response<T>>;
    request<T = any>(method: string, url: string, data?: any): Promise<Response<T>>;
    get<T = any>(url: string, data?: any): Promise<Response<T>>;
    post<T = any>(url: string, data?: any): Promise<Response<T>>;
    put<T = any>(url: string, data?: any): Promise<Response<T>>;
    delete<T = any>(url: string, data?: any): Promise<Response<T>>;
}
export default Api;
